/* -*- c++ -*-
   $Id: controller.h,v 1.1 2004/03/17 15:32:25 admin Exp $
*/
#ifndef _SHIORIBOX_CONTROLLER_H_INCLUDED_
#define _SHIORIBOX_CONTROLLER_H_INCLUDED_
#include <exception>
#include <map>
#include <boost/utility.hpp>
#include <boost/shared_ptr.hpp>

namespace shioribox {
    namespace ctrl {
	class controller;
	class __string_exception;
	class start_failed_exception;
	class out_of_control_exception;
    };
};

class shioribox::ctrl::__string_exception : public std::exception {
private:
    std::string msg;
public:
    __string_exception(const std::string& msg) throw ()
	:msg(msg) {}
    virtual ~__string_exception() throw () {}
    const char* what() const throw () {
	return msg.c_str();
    }
};

class shioribox::ctrl::start_failed_exception
    : public shioribox::ctrl::__string_exception {
public:
    start_failed_exception(const std::string& msg) throw ()
	: __string_exception(msg) {}
};

class shioribox::ctrl::out_of_control_exception
    : public shioribox::ctrl::__string_exception {
public:
    out_of_control_exception(const std::string& msg) throw ()
	: __string_exception(msg) {}
};


class shioribox::ctrl::controller : boost::noncopyable {
private:
    class impl;
    boost::shared_ptr<impl> pimpl;

public:
    controller(
	const std::string& shioribox_path, // shioriboxХʥؤΥѥ
	const std::string& shiori_name, // shioriboxΥץ̾˻Ȥ̾
	const std::string& shiori_module, // ΤؤΥѥ
	const std::map<std::string, std::string>& additional_env, // ɲäĶѿ
	const std::string& ghost_path) // ٤load()Ϥѥ
	throw (shioribox::ctrl::start_failed_exception);
    ~controller();

    std::string request(const std::string& req)
	throw (shioribox::ctrl::out_of_control_exception);
};

#endif /* _SHIORIBOX_CONTROLLER_H_INCLUDED_ */
