/* -*- c++ -*-
   $Id: shiori_accessor.cpp,v 1.1.1.1 2004/02/09 20:51:41 admin Exp $
*/
#include "shiori_accessor.h"
#include <dlfcn.h>
#include <stdlib.h>
#include <string.h>
#include <iostream>
#include <new>
using namespace std;
using namespace boost;
using namespace shioribox;

shiori_accessor::shiori_accessor(const std::string& fpath)
    throw (shioribox::bad_module_exception)
    : fpath(fpath) {
    // Υ饤֥dlopen & dlsym
	handle.reset(dlopen(fpath.c_str(), RTLD_LAZY), handle_deleter());
    if (!handle) {
	throw bad_module_exception(fpath, dlerror());
    }

    sym_load = reinterpret_cast<int(*)(char*, long)>(
	dlsym(handle.get(), "load"));
    if (!sym_load) {
	throw bad_module_exception(fpath, dlerror());
    }

    sym_unload = reinterpret_cast<int(*)()>(
	dlsym(handle.get(), "unload"));
    if (!sym_unload) {
	throw bad_module_exception(fpath, dlerror());
    }

    sym_request = reinterpret_cast<char*(*)(char*, long*)>(
	dlsym(handle.get(), "request"));
    if (!sym_request) {
	throw bad_module_exception(fpath, dlerror());
    }
}

void shiori_accessor::handle_deleter::operator() (void* handle) {
    if (handle == NULL) {
	return;
    }

    // deleterεˤꡢΥ᥽åɤthrowƤϤʤʤġ
    if (dlclose(handle) != 0) {
	cerr << dlerror() << endl;
    }
}

static char* malloc_str(const string& str) {
    char* cstr = static_cast<char*>(malloc(str.length()));
    if (!cstr) {
	throw bad_alloc(); // ⤷顢ɤʤΤʤ
    }
    memcpy(cstr, str.c_str(), str.length());
    return cstr;
}

bool shiori_accessor::load(const string& fpath) const {
    return sym_load(malloc_str(fpath), static_cast<long>(fpath.length()));
}

bool shiori_accessor::unload() const {
    return sym_unload();
}

std::string shiori_accessor::request(const std::string& req) const {
    long len = req.length();
    char* reply = sym_request(malloc_str(req), &len);
    string str_reply(reply, len);
    free(reply);
    return str_reply;
}
