/* -*- c++ -*-
   $Id: shiori_accessor.h,v 1.1.1.1 2004/02/09 20:51:41 admin Exp $
*/
#ifndef _SHIORI_ACCESSOR_H_INCLUDED_
#define _SHIORI_ACCESSOR_H_INCLUDED_
#include "config.h"
#include <string>
#include <exception>
#include <boost/shared_ptr.hpp>
#include <boost/function.hpp>

namespace shioribox {
    class shiori_accessor;
    class bad_module_exception;
};

class shioribox::bad_module_exception : std::exception {
private:
    std::string fpath;
    std::string message;
    std::string what_str;
public:
    bad_module_exception(
	const std::string& fpath,
	const std::string& message) throw ()
	:fpath(fpath),
	 message(message)  {
	what_str = fpath + " - " + message;
    }
    virtual ~bad_module_exception() throw () {}
    virtual const char* what() const throw () {
	return what_str.c_str();
    }
};

/*
  Υ饹ԲĤʣġ
  (ȻפĤˤǤ)
*/

class shioribox::shiori_accessor {
private:
    std::string fpath;
    boost::shared_ptr<void> handle;
    boost::function<int (char* data, long length)> sym_load;
    boost::function<int ()> sym_unload;
    boost::function<char* (char* data, long* length)> sym_request;

    class handle_deleter {
    public:
	void operator() (void* handle);
    };

public:
    shiori_accessor(const std::string& fpath)
	throw (shioribox::bad_module_exception);
    ~shiori_accessor() {}

    bool load(const std::string& path) const;
    bool unload() const;
    std::string request(const std::string& req) const;
};

#endif /* _SHIORI_ACCESSOR_H_INCLUDED_ */
