/* -*- c++ -*-
   $Id: shiori_session.h,v 1.2 2004/03/17 15:32:25 admin Exp $
*/
#ifndef _SHIORI_SESSION_H_INCLUDED_
#define _SHIORI_SESSION_H_INCLUDED_
#include "config.h"
#include "shiori_accessor.h"
#include <iostream>
#include <string>
#include <vector>
#include <boost/utility.hpp>

namespace shioribox {
    class shiori_session;
};

class shioribox::shiori_session : boost::noncopyable {
private:
    bool convert_crlf;
    shioribox::shiori_accessor shiori;
    std::istream input;
    std::ostream output;
    bool started_already;

    static void fix_dialogue(std::string& dialogue, bool is_request);
    static void warn_strange_dialogue(
	bool is_request,
	const std::vector<std::string>& lines,
	const std::string& message,
	unsigned position);

public:
    shiori_session(
	bool convert_crlf,
	const shioribox::shiori_accessor& shiori,
	const std::istream& input,
	const std::ostream& output)
	: convert_crlf(convert_crlf),
	  shiori(shiori),
	  input(input.rdbuf()),   // istream/ostreamԡ󥹥ȥ饯
	  output(output.rdbuf()), // ǽǤʤΤϰΰ٤
	  started_already(false) {}
    int start(const std::string& rootdir);
};

// __strˤϲԥɤʤ
template<typename _CharT, typename _Traits, typename _Alloc>
std::basic_istream<_CharT,_Traits>&
getline(
    std::basic_istream<_CharT, _Traits>& __is,
    std::basic_string<_CharT, _Traits, _Alloc>& __str,
    bool accept_lf = true, bool accept_crlf = true);

template<typename _CharT, typename _Traits, typename _Alloc>
std::basic_string<_CharT, _Traits, _Alloc>&
replace(
    std::basic_string<_CharT, _Traits, _Alloc>& __str,
    const std::basic_string<_CharT, _Traits, _Alloc>& __from,
    const std::basic_string<_CharT, _Traits, _Alloc>& __to);

#endif /* _SHIORI_SESSION_H_INCLUDED_ */
